﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

///
///文本分类特征数据生成源代码，版权所有 2016 张磊
///有关于此程序代码的详细说明，
///参见 http://www.qiantec.cn/post/wb1
///
namespace PreData
{
    class Program
    {
        static void Main(string[] args)
        {
            Program p = new Program();
            p.Start();
        }

        private void Start()
        {
            DateTime dtStart = DateTime.Now;
            int weishu = 1024;
            System.Text.RegularExpressions.Regex reg = new System.Text.RegularExpressions.Regex(
                "第\\d+页",
                System.Text.RegularExpressions.RegexOptions.Compiled |
                System.Text.RegularExpressions.RegexOptions.Singleline |
                System.Text.RegularExpressions.RegexOptions.IgnoreCase);
            System.Text.RegularExpressions.Regex reg2 = new System.Text.RegularExpressions.Regex(
                "共找到([\\d,\\s]+)个相关网页",
                System.Text.RegularExpressions.RegexOptions.Singleline |
                System.Text.RegularExpressions.RegexOptions.Compiled);

            ZMinMax[] mms = new ZMinMax[weishu];
            for (int t = 0; t < mms.Length; t++)
                mms[t] = new ZMinMax();

            foreach (var dir in System.IO.Directory.GetDirectories(@"d:\ClassFile"))
            {
                System.Console.WriteLine("数据加载及分析 第一阶段 目录 " + dir);
                foreach (var file in System.IO.Directory.GetFiles(dir))
                {
                    var txt = System.IO.File.ReadAllText(file);
                    if (txt.Length < 15)
                        continue;
                    var idx = txt.IndexOf("搜狗(www.sogou.com)搜索");
                    if (idx != -1)
                        txt = txt.Substring(0, idx);
                    txt = txt.Replace("上一页", "").Replace("下一页", "");
                    txt = reg.Replace(txt, "");
                    txt = reg2.Replace(txt, "");
                    var fi = textzipin.GetZiPin(txt, weishu);
                    for (int t = 0; t < mms.Length; t++)
                        mms[t].SetMinMax(fi[t]);
                }
            }
            System.Console.WriteLine("第一阶段分析完成。");
            System.Text.StringBuilder sb = new StringBuilder();
            foreach (var dir in System.IO.Directory.GetDirectories(@"d:\ClassFile"))
            {
                System.Console.WriteLine("数据加载及分析 第二阶段 目录  " + dir);
                var bjsl = dir.Contains("C000024");
                foreach (var file in System.IO.Directory.GetFiles(dir))
                {
                    var txt = System.IO.File.ReadAllText(file);
                    if (txt.Length < 15)
                        continue;
                    var idx = txt.IndexOf("搜狗(www.sogou.com)搜索");
                    if (idx != -1)
                        txt = txt.Substring(0, idx);
                    txt = txt.Replace("上一页", "").Replace("下一页", "");
                    txt = reg.Replace(txt, "");
                    txt = reg2.Replace(txt, "");
                    var fi = textzipin.GetZiPin(txt, weishu);
                    for (int t = 0; t < mms.Length; t++)
                        fi[t] = fi[t] / mms[t].fmax;
                    sb.Append((bjsl ? "1" : "0"));
                    for (int t = 0; t < mms.Length; t++)
                        sb.Append(" " + (t + 1) + ":" + fi[t]);
                    sb.AppendLine();
                }
            }
            System.Console.WriteLine("第二阶段分析完成。\r\n开始生成特征数据文件。");
            System.IO.File.WriteAllText("d:\\data.txt", sb.ToString());
            System.Console.WriteLine("任务完成，耗时 " + (DateTime.Now-dtStart) + "\r\n特征数据文件已经保存到d盘根目录下的data.txt中。\r\n按回车键退出程序。");
            System.Console.ReadLine();
        }
    }
}