﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

///
///文本分类特征数据生成源代码，版权所有 2016 张磊
///有关于此程序代码的详细说明，
///参见 http://www.qiantec.cn/post/wb1
///
namespace PreData
{
    public class textzipin
    {
        const int magiccount = 40967291;
        public static zipininfo[] zps;
        static textzipin()
        {
            System.Collections.Generic.Queue<zipininfo> qzps = new Queue<zipininfo>();
            var lines = PreData.Properties.Resources.outzp.Split("\r\n".ToCharArray());
            foreach (var line in lines)
            {
                if (line == "")
                    continue;
                var texts = line.Split(",".ToCharArray());
                zipininfo zp = new zipininfo();
                zp.ch = texts[0];
                zp.zipin = float.Parse(texts[1]) * 1000 / magiccount;
                qzps.Enqueue(zp);
            }
            zps = qzps.ToArray();
        }
        public static float[] GetZiPin(string str, int keycount)
        {
            float[] res = new float[keycount];
            if (str == null || keycount > zps.Length)
                return res;
            System.Collections.Generic.Dictionary<string, int> dsi = new Dictionary<string, int>();
            var avcount = 0;
            foreach (var k in str)
            {
                if (char.GetUnicodeCategory(k) == System.Globalization.UnicodeCategory.OtherLetter)
                {
                    var ks = k.ToString();
                    if (dsi.ContainsKey(ks))
                        dsi[ks]++;
                    else
                        dsi[ks] = 1;
                    avcount++;
                }
            }
            for (int i = 0; i < keycount; i++)
            {
                if (dsi.ContainsKey(zps[i].ch))
                {
                    res[i] = dsi[zps[i].ch] * 1000f / avcount;
                    res[i] = res[i] / zps[i].zipin / 2;
                }
            }
            return res;
        }
    }
    public class zipininfo
    {
        public string ch;
        public float zipin;
    }
}